% eda10_01
% illustrate problem associated with interpolation by
% fitting a high-order polynomial

% unevenly samples times
t = [0.01, 0.11, 0.24, 0.38, 0.42, 0.57, 0.62, 0.77, 0.81, 0.91, 0.99]';
N=length(t);

% simple function
f0=2;
c=2;
d = sin(2*pi*f0*t).*exp(-c*t);
d = t/2 + [0.1, -0.1, 0.1, -0.1, 0.1, -0.1, 0.1, -0.1, 0.1, -0.1, 0.1]';

% plot simple function
figure(1);
clf;
axis([0, 1, -5, 5]);
hold on;
set(gca,'LineWidth',2);
plot(t,d,'ko','LineWidth',2);

% linear representation of polynomial relationship
G=zeros(N,N);
for i = [1:N]
    G(:,i)=t.^(i-1);
end

% solve for coefficients
m = G\d;

% evaluate at equally-spaced values of t
Np=101;
tp = 0.01*[0:Np-1]';
Gp=zeros(Np,N);
for i = [1:N]
    Gp(:,i)=tp.^(i-1);
end
dp=Gp*m;

% plot simple function
plot(tp,dp,'k-','LineWidth',2);

